<template>
  <main>
    <mt-page-title :link-to="{ name: 'profil-dashboard-activites' }" link-text="Annuler">
      <h1 class="has-text-weight-bold is-size-3">Modification d'une activité</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-form-fields-activity
        :activite="activite"
        :organismes="organismes"
        :modifier="true"
        :effectif-previsionnel="effectifPrevisionnel"
        :pax-max="nombrePax"
        @majEffectifPrevisionnel="majEffectifPrevisionnel"
      >
        <b-field label="Organisme de l’activité ">
          <b-select
            v-model="activite.organisme.id"
            :value="activite.organisme"
            placeholder="Choisir un organisme"
            expanded
          >
            <optgroup v-for="list in getListeOrganisme()" :key="list[0]" :label="list[0]">
              <option v-for="userOrganisme in list[1]" :key="userOrganisme.id" :value="userOrganisme.id">
                {{ userOrganisme.libelle }}
              </option>
            </optgroup>
          </b-select>
        </b-field>
      </mt-form-fields-activity>
      <div class="columns is-centered">
        <b-button type="is-primary" native-type="submit">
          Enregistrer les modifications
        </b-button>
      </div>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtFormFieldsActivity from '~/components/activity/form-fields-activity';
import { newActivity } from '~/components/mixins/activityMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtFormFieldsActivity,
  },
  async asyncData(context) {
    const activite = Object.assign(newActivity(context.store), await context.$api.activites.get(context.params.id));
    const [nombrePax, organismes, effectifPrevisionnel] = await Promise.all([
      context.$api.activites.nombreDePax(activite.organisme.id),
      context.$api.organismes.affectableAllowed(),
      context.$api.organisme().disponibilitesComplete(activite.dateDebut.toISOString(), activite.dateFin.toISOString()),
    ]);
    return {
      effectifPrevisionnel,
      organismes,
      activite,
      nombrePax,
    };
  },
  methods: {
    getListeOrganisme() {
      const organismes = new Map();
      this.organismes.forEach(function setOrganismes(organisme) {
        let tabOrg = organismes.get(organisme.codeParent);
        if (!tabOrg) {
          tabOrg = [];
        }
        tabOrg.push(organisme);
        organismes.set(organisme.codeParent, tabOrg);
      });
      return Array.from(organismes);
    },
    async submit() {
      try {
        await this.$api.activites.put(this.activite.id, this.activite);
        this.$router.push({ name: 'profil-dashboard-activites' });
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
    async majEffectifPrevisionnel() {
      if (this.activite.dateDebut && this.activite.dateFin) {
        this.effectifPrevisionnel = await this.$api
          .organisme()
          .disponibilitesComplete(this.activite.dateDebut.toISOString(), this.activite.dateFin.toISOString());
      }
    },
  },
};
</script>

<style scoped lang="scss"></style>
